
const St = imports.gi.St;
const Main = imports.ui.main;
const Keyboard = imports.ui.keyboard.Keyboard;
const Me = imports.misc.extensionUtils.getCurrentExtension();

const Gio = imports.gi.Gio;
const GLib = imports.gi.GLib;


let showBackup
let hideBackup

const A11Y_APPLICATIONS_SCHEMA = 'org.gnome.desktop.a11y.applications';
const SHOW_KEYBOARD = 'screen-keyboard-enabled';

let _oskButton;
let _oskButtonEventHandler;
let _oskA11yApplicationsSettings;
let state = false;
let icon;
function _toggleKeyboard() {
    if(state){
        Keyboard.prototype['show'] = function() {
             return;
       }
       icon = new St.Icon({ gicon: Gio.icon_new_for_string(Me.path+'/disabled.svg'),
                            style_class: 'system-status-icon' });

    }else{
        Keyboard.prototype['show'] = showBackup
        icon = new St.Icon({ gicon: Gio.icon_new_for_string(Me.path+'/enabled.svg'),
                            style_class: 'system-status-icon' });
  }
    _oskButton.set_child(icon);
    state=!state;
}

function init() {
}

function enable() {
    showBackup = Keyboard.prototype['show']
   _oskA11yApplicationsSettings = new Gio.Settings({ schema_id: A11Y_APPLICATIONS_SCHEMA });

    _oskButton = new St.Bin({ style_class: 'panel-button',
                            reactive: true,
                            can_focus: true,
                            track_hover: true });
    _toggleKeyboard();
    _oskButtonEventHandler = _oskButton.connect('button-press-event', _toggleKeyboard);

    Main.panel._rightBox.insert_child_at_index(_oskButton, 0);

}

function disable() {
    Main.panel._rightBox.remove_child(_oskButton);

    _oskButton.disconnect(_oskButtonEventHandler);
    _oskButton = null;
    _oskButtonEventHandler = null;

    _oskA11yApplicationsSettings = null;
}
